aboutsummaryrefslogtreecommitdiffstats
path: root/target/linux/ramips/mt7621/base-files/sbin/fixup-mac-address
diff options
context:
space:
mode:
authorAdrian Schmutzler <freifunk@adrianschmutzler.de>2019-10-22 12:37:13 +0200
committerAdrian Schmutzler <freifunk@adrianschmutzler.de>2019-11-03 00:26:17 +0100
commit19724e28c81e3ff642f09c49f612cd147c54a697 (patch)
tree278c45d3b1563cee6108e65c3b5856dbab304062 /target/linux/ramips/mt7621/base-files/sbin/fixup-mac-address
parent0975c35b83a632f9662d1944307f87da9db06154 (diff)
downloadupstream-19724e28c81e3ff642f09c49f612cd147c54a697.tar.gz
upstream-19724e28c81e3ff642f09c49f612cd147c54a697.tar.bz2
upstream-19724e28c81e3ff642f09c49f612cd147c54a697.zip
ramips: split base-files into subtargets
While most of the target's contents are split into subtargets, the base-files are maintained for the target as a whole. However, OpenWrt already implements a mechanism that will use (and even prefer) files in the subtargets' directories. This can be exploited to make several scripts subtarget-specific and thus save some space. In certain cases, keeping files in parent (=target) base-files was more convenient, and thus no splitting was performed for those. Note that this will increase overall code lines, but reduce code per subtarget. base-files ipk size reduction: master (mt7621) 60958 B split (mt7620) 46358 B (- 14.3 kiB) split (mt7621) 48759 B (- 11.9 kiB) split (mt76x8) 44948 B (- 15.6 kiB) split (rt288x) 43508 B (- 17.0 kiB) split (rt305x) 45616 B (- 15.0 kiB) split (rt3883) 44176 B (- 16.4 kiB) Run-tested on: GL.iNet GL-MT300N-V2 (mt76x8) D-Link DWR-116 (mt7620) Signed-off-by: Adrian Schmutzler <freifunk@adrianschmutzler.de>
Diffstat (limited to 'target/linux/ramips/mt7621/base-files/sbin/fixup-mac-address')
-rwxr-xr-xtarget/linux/ramips/mt7621/base-files/sbin/fixup-mac-address80
1 files changed, 80 insertions, 0 deletions
diff --git a/target/linux/ramips/mt7621/base-files/sbin/fixup-mac-address b/target/linux/ramips/mt7621/base-files/sbin/fixup-mac-address
new file mode 100755
index 0000000000..dad15c5842
--- /dev/null
+++ b/target/linux/ramips/mt7621/base-files/sbin/fixup-mac-address
@@ -0,0 +1,80 @@
+#!/bin/sh
+. /lib/functions.sh
+. /lib/functions/system.sh
+
+partname=""
+offset=""
+NEW_MAC=
+YES=
+
+board=$(board_name)
+case $board in
+ mqmaker,witi)
+ partname=factory
+ offset=$((0xe000))
+ ;;
+ *)
+ echo "Unsupported board"
+ exit 1
+ ;;
+esac
+
+while [ -n "$1" ]; do
+ case "$1" in
+ ??:??:??:??:??:??) NEW_MAC="$1";;
+ -y) YES=1;;
+ *)
+ cat <<EOF
+Unknown option/argument '$1'
+Usage: $0 [-y] [<macaddr>]
+EOF
+ exit 1
+ ;;
+ esac
+ shift
+done
+
+ask_bool() {
+ local message="$1"
+ local default="$((! ${2:-0}))"
+ [ -n "$YES" ] && return 0
+ echo -n "$message "
+ read opt
+ case "$opt" in
+ y|Y) return 0;;
+ n|N) return 1;;
+ *) return $default;;
+ esac
+}
+
+convert_hex() {
+ hexdump -e '/1 "%02x "'
+}
+
+gen_mac() {
+ dd if=/dev/urandom bs=6 count=1 2>/dev/null
+}
+
+mac="$(mtd_get_mac_binary $partname $offset)"
+case "$mac" in
+ 00:00:00:00:00:00);;
+ ff:ff:ff:ff:ff:ff);;
+ *)
+ echo "Current MAC address: $mac"
+ ask_bool "Overwrite (y/N)?" 0 || exit
+ ;;
+esac
+
+if [ -n "$NEW_MAC" ]; then
+ set -- $(echo "$NEW_MAC" | sed 's,:, ,g')
+else
+ set -- $(gen_mac | convert_hex)
+ set -- $(printf %02x $(( (0x$1 & 0xfe) | 0x02 ))) $2 $3 $4 $5 $6
+fi
+echo "New MAC address: $1:$2:$3:$4:$5:$6"
+ask_bool "Write to EEPROM (y/N)?" || exit
+
+part=$(find_mtd_part "$partname")
+[ -n "$part" ] || exit
+echo -ne "\x$1\x$2\x$3\x$4\x$5\x$6" | dd of=$part conv=notrunc bs=1 count=6 seek=$offset 2>/dev/null
+echo "Done"